datablock AudioProfile(cashBagActivateSound)
{
   filename    = "./sound/grabBag.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(cashBagFireSound)
{
   filename    = "./sound/swingBag.wav";
   description = AudioClose3d;
   preload = true;
};
//Effects
datablock ParticleData(cashExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "./image/cash";
   colors[0]     = "0 0.8 0 0.8";
   colors[1]     = "1 1 1 1";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(cashExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "cashExplosionParticle";

   uiName = "Cash Emitter";
};
datablock ExplosionData(cashExplosion)
{
   lifeTimeMS = 500;

   soundProfile = cashBagActivateSound;

   particleEmitter = cashExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 4;
   lightStartColor = "0 0.8 0.4";
   lightEndColor = "0 0.8 0.6";
};
//Projectile
AddDamageType("cashBagDirect",   '<bitmap:add-ons/Weapon_cashBag/image/ciBag> %1',       '%2 <bitmap:add-ons/Weapon_cashBag/image/ciBag> %1',1,1);

datablock ProjectileData(cashBagkillProjectile)
{
   backstab		= 25;
   directDamage        = 20;
   directDamageType  = $DamageType::cashBagDirect;
   radiusDamageType  = $DamageType::cashBagRadius;
   explosion           = cashExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 77;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.02;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0.8 0.2";
};

//Item
datablock ItemData(cashBagItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "./model/cashBag.dts";
	mass = 1.2;
	density = 0.12;
	elasticity = 0.15;
	friction = 0.7;
	emap = true;

	//gui stuff
	uiName = "Cash Bag";
	iconName = "./image/iconBag";
	doColorShift = false;

	// Dynamic properties defined by the scripts
	image = cashBagImage;
	canDrop = true;
};

//Weapon
datablock ShapeBaseImageData(cashBagImage)
{
   // Basic Item properties
   shapeFile = "./model/cashBag.dts";
   emap = true;
   mountPoint = 0;
   offset = "-0.125 0.07 -0.61";
   correctMuzzleVector = true;
   className = "WeaponImage";
   scale = "6 6 6";

   // Projectile && Ammo.
   item = cashBagItem;
   ammo = " ";
   projectile = cashBagkillProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   
   //raise your arm up or not
   armReady = true;
   doColorShift = false;

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "activate";
	stateSound[0]					= cashBagactivateSound;

	stateName[1]			= "Ready";
	stateSequence[1]		= "ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateScript[2]			= "oncharge";
	stateSequence[2]		= "ready";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortChargefire";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortChargefire";
	stateTransitionOnTimeout[3]	= "stopfire";
	stateTimeoutValue[3]		= 0.2;
	stateFire[3]			= true;
	stateSequence[3]		= "ready";
	stateScript[3]			= "onFiretwo";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= true;
	stateSound[3]				= cashBagFireSound;
	
	
	stateName[4]                    = "StopFire";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 0.2;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;

	stateScript[4]                  = "onStopFire";

	
	stateName[5]			= "Armed";
	stateTransitionOnTriggerUp[5]	= "Fire";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Fire";
	stateTransitionOnTimeout[6]	= "Ready";
	stateTimeoutValue[6]		= 0.2;
	stateFire[6]			= true;
	stateSequence[6]		= "ready";
	stateScript[6]			= "onFire";
	stateWaitForTimeout[6]		= true;
	stateAllowImageChange[6]	= false;
	stateSound[6]				= cashBagFireSound;
};

function cashBagImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}
function cashBagImage::onfiretwo(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
	return;
}
function cashBagImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function cashBagImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}
//Mount to player
datablock ShapeBaseImageData(cashBagBackImage) //An alternate image to be mounted on their back.
{
	shapeFile				= "./model/cashBag.dts";
	emap					= true;

	mountPoint				= 7; //On their back.
	offset					= "0 -0.4 0.70";
	eyeOffset				= "0 9999 0"; //Nothing to see in first person here.
	rotation				= eulerToMatrix( "-16 0 90" );
	scale					= "6 6 6";
	correctMuzzleVector		= true;

	className				= "WeaponImage";
	firstPerson				= 0;

	doColorShift			= false;
	colorShiftColor			= "0.196 0.196 0.196 0.5";
};

function cashBagImage::onUnMount(%this, %obj, %slot)
	{
		Parent::onUnMount(%this, %obj, %slot);
		for(%i=0;%i<%obj.getDatablock().maxTools;%i++) //Make sure we haven't dropped it.
		{
			%item = %obj.tool[%i];
			if(%item == cashBagItem.getID() && %i != %obj.currtool)
			{
				%obj.mountimage(cashBagBackImage, 2); //Put it on our back.
				break;
			}
		}
	}
	function cashBagImage::onMount(%this, %obj, %slot)
	{
		Parent::onMount(%this, %obj, %slot);
		%obj.unmountimage(2); //Get it off our back.
	}
	function cashBagItem::onPickup(%this, %obj, %col, %a)
	{
		%col.mountimage(cashBagBackImage,2);
		messageAll(''," "@%col.client.getPlayerName()@" \c6 has the cash!");
	    parent::onPickup(%this, %obj, %col, %a);		
		if(%item == cashBagItem.getID() && %i != %col.currtool)
		{
			%col.mountimage(cashBagBackImage,2);
		}
	}
	
package cashDrop
{
	function gameConnection::onDeath(%client, %source, %killer, %type, %location)
	{
	%player = %client.player;
	if(!isObject(%player))
	return Parent::onDeath(%client, %source, %killer, %type, %location);
	for(%i=0;%i<%client.player.getDatablock().maxtools;%i++)
	{
	%item = %player.tool[%i];
	if(isObject(%item) && %item.getID() == cashBagItem.getID())
	{
	%position = %player.getPosition();
	%velocity = %player.getVelocity();
	%item = new Item() 
	{
	datablock = %item;
	position = %position;
    };
	%item.setVelocity(vectorAdd(%velocity, getRandom(-2,2) SPC getRandom(-2, 2) SPC 2));
	%item.BL_ID = %client.BL_ID;
	%item.minigame = %client.minigame;
	%item.spawnBrick = 01;
	%item.schedulePop();
	break;
	}
	}
	return Parent::onDeath(%client, %source, %killer, %type, %location);
	}
};
activatePackage("cashDrop");